/**
 * Copyright (c) 2013 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda3/).
 */
package org.xmloperator.lambda3.impl;

import org.xmloperator.lambda3.exception.IllegalFunctionArgumentException;
import org.xmloperator.lambda3.model.Function1;
import org.xmloperator.lambda3.model.NumberCoding;
import org.xmloperator.lambda3.model.Term;

/**
 * Function that maps to an int value.
 */
final class FunctionInt implements Function1 {
	final int intValue;
	
	FunctionInt(int intValue) {
		this.intValue = intValue;
	}
	
	//////////////////////////
	// Function implementation
	//////////////////////////

	public String getName() {
		return NumberCoding.INT + String.valueOf(this.intValue);
	}
	
	public boolean acceptArgument(int index, Term arg) {
		return false;
	}
	
	///////////////////////////
	// Function1 implementation
	///////////////////////////
	
	public Term function(Term arg) {
		throw new IllegalFunctionArgumentException(this, arg);
	}
}
