/**
 * Copyright (c) 2013 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda3/).
 */
package org.xmloperator.lambda3.model;

/**
 * A Term that is an application.
 */
public interface Application extends Term {

	/**
	 * @return the function Term of this Application.
	 */
	public Term getFunction();

	/**
	 * @return the argument Term of this Application.
	 */
	public Term getArgument();

	/**
	 * @return <tt>true</tt> if this Application is a redex (reducible
	 *         expression), i.e. if its function Term is an Abstraction or a
	 *         Constant.
	 */
	public boolean isRedex();
}
