/**
 * Copyright (c) 2013 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda3/).
 */
package org.xmloperator.lambda3.util;

import java.lang.reflect.Array;

public final class Stack<T> {
	private final T[] array;
	private int size = 0;

	@SuppressWarnings("unchecked")
	public Stack(Class<T> elementClass, int capacity) {
		this.array = (T[]) Array.newInstance(elementClass, capacity);
	}

	public int getSize() {
		return this.size;
	}

	public void push(T element) {
		if (this.size == array.length)
			return;
		this.array[this.size++] = element;
	}

	public T pop() {
		if (this.size == 0)
			return null;
		return array[--this.size];
	}
}
